org.jboss.resteasy.plugins.providers.jaxb

## Class JAXBXmlTypeProvider

- java.lang.Object
- - org.jboss.resteasy.plugins.providers.AbstractEntityProvider<T>
  - - org.jboss.resteasy.plugins.providers.jaxb.AbstractJAXBProvider<Object>
    - - org.jboss.resteasy.plugins.providers.jaxb.JAXBXmlTypeProvider

- All Implemented Interfaces:
    MessageBodyReader<Object>, MessageBodyWriter<Object>
  Direct Known Subclasses:
    FastinfoSetXmlTypeProvider, JettisonXmlTypeProvider

      @Provider
      @Produces(value={"application/*+xml","text/*+xml"})
      @Consumes(value={"application/*+xml","text/*+xml"})
      public class JAXBXmlTypeProvider
      extends AbstractJAXBProvider<Object>

  A JAXB entity provider that handles classes without `XmlRootElement` annotation. Classes which have been generated by XJC will most likely not contain this annotation, In order for these classes to marshalled, they must be wrapped within a `JAXBElement` instance. This is typically accomplished by invoking a method on the class which serves as the `XmlRegistry` and is named ObjectFactory.

  This provider is selected when the class is annotated with an `XmlType` annotation and not an `XmlRootElement` annotation.

  This provider simplifies this task by attempting to locate the `XmlRegistry` for the target class. By default, a JAXB implementation will create a class called ObjectFactory and is located in the same package as the target class. When this class is located, it will contain a "create" method that takes the object instance as a parameter. For example, of the target type is called "Contact", then the ObjectFactory class will have a method:

  `public JAXBElement createContact(Contact value);`
  Version:
    $Revision:$
  Author:
    Ryan J. McDonough

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static String` | `OBJECT_FACTORY_NAME`

    - ### Fields inherited from class org.jboss.resteasy.plugins.providers.jaxb.AbstractJAXBProvider

      `providers`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JAXBXmlTypeProvider()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static Object` | `findObjectFactory(Class<?> type)` Attempts to locate `XmlRegistry` for the XML type.
    `protected boolean` | `isReadWritable(Class<?> type, Type genericType, Annotation[] annotations, MediaType mediaType)` FIXME Comment this
    `Object` | `readFrom(Class<Object> type, Type genericType, Annotation[] annotations, MediaType mediaType, MultivaluedMap<String,String> httpHeaders, InputStream entityStream)` Read a type from the `InputStream`.
    `static JAXBElement<?>` | `wrapInJAXBElement(Object t, Class<?> type)` If this object is managed by an XmlRegistry, this method will invoke the registry and wrap the object in a JAXBElement so that it can be marshalled.
    `void` | `writeTo(Object t, Class<?> type, Type genericType, Annotation[] annotations, MediaType mediaType, MultivaluedMap<String,Object> httpHeaders, OutputStream entityStream)` Write a type to an HTTP message.

    - ### Methods inherited from class org.jboss.resteasy.plugins.providers.jaxb.AbstractJAXBProvider

      `decorateMarshaller, decorateUnmarshaller, findJAXBContext, getCharset, getMarshaller, isDisableDTDs, isDisableExternalEntities, isEnableSecureProcessingFeature, isReadable, isWriteable, needsSecurity, processWithSecureProcessing, setCharset, setDisableDTDs, setDisableExternalEntities, setEnableSecureProcessingFeature`

    - ### Methods inherited from class org.jboss.resteasy.plugins.providers.AbstractEntityProvider

      `getSize`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### OBJECT_FACTORY_NAME

          protected static final String OBJECT_FACTORY_NAME

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### JAXBXmlTypeProvider

          public JAXBXmlTypeProvider()

  - ### Method Detail

    - #### writeTo

          public void writeTo(Object t,
                     Class<?> type,
                     Type genericType,
                     Annotation[] annotations,
                     MediaType mediaType,
                     MultivaluedMap<String,Object> httpHeaders,
                     OutputStream entityStream)
                       throws IOException

      Description copied from interface: `MessageBodyWriter`
      Write a type to an HTTP message. The message header map is mutable but any changes must be made before writing to the output stream since the headers will be flushed prior to writing the message body.
      Specified by:
        `writeTo` in interface `MessageBodyWriter<Object>`
      Overrides:
        `writeTo` in class `AbstractJAXBProvider<Object>`
      Parameters:
        `t` - the instance to write.
        `type` - the class of instance that is to be written.
        `genericType` - the type of instance to be written. `GenericEntity` provides a way to specify this information at runtime.
        `annotations` - an array of the annotations attached to the message entity instance.
        `mediaType` - the media type of the HTTP entity.
        `httpHeaders` - a mutable map of the HTTP message headers.
        `entityStream` - the `OutputStream` for the HTTP entity. The implementation should not close the output stream.
      Throws:
        `IOException` - if an IO error arises.

    - #### readFrom

          public Object readFrom(Class<Object> type,
                        Type genericType,
                        Annotation[] annotations,
                        MediaType mediaType,
                        MultivaluedMap<String,String> httpHeaders,
                        InputStream entityStream)
                          throws IOException

      Description copied from interface: `MessageBodyReader`
      Read a type from the `InputStream`.

      In case the entity input stream is empty, the reader is expected to either return a Java representation of a zero-length entity or throw a `NoContentException` in case no zero-length entity representation is defined for the supported Java type. A `NoContentException`, if thrown by a message body reader while reading a server request entity, is automatically translated by JAX-RS server runtime into a `BadRequestException` wrapping the original `NoContentException` and rethrown for a standard processing by the registered `exception mappers`.

      Specified by:
        `readFrom` in interface `MessageBodyReader<Object>`
      Overrides:
        `readFrom` in class `AbstractJAXBProvider<Object>`
      Parameters:
        `type` - the type that is to be read from the entity stream.
        `genericType` - the type of instance to be produced. E.g. if the message body is to be converted into a method parameter, this will be the formal type of the method parameter as returned by `Method.getGenericParameterTypes`.
        `annotations` - an array of the annotations on the declaration of the artifact that will be initialized with the produced instance. E.g. if the message body is to be converted into a method parameter, this will be the annotations on that parameter returned by `Method.getParameterAnnotations`.
        `mediaType` - the media type of the HTTP entity.
        `httpHeaders` - the read-only HTTP headers associated with HTTP entity.
        `entityStream` - the `InputStream` of the HTTP entity. The caller is responsible for ensuring that the input stream ends when the entity has been consumed. The implementation should not close the input stream.
      Returns:
        the type that was read from the stream. In case the entity input stream is empty, the reader is expected to either return an instance representing a zero-length entity or throw a `NoContentException` in case no zero-length entity representation is defined for the supported Java type.
      Throws:
        `IOException` - if an IO error arises. In case the entity input stream is empty and the reader is not able to produce a Java representation for a zero-length entity, `NoContentException` is expected to be thrown.

    - #### isReadWritable

          protected boolean isReadWritable(Class<?> type,
                               Type genericType,
                               Annotation[] annotations,
                               MediaType mediaType)

      Description copied from class: `AbstractJAXBProvider`
      FIXME Comment this
      Specified by:
        `isReadWritable` in class `AbstractJAXBProvider<Object>`
      Returns:

    - #### findObjectFactory

          public static Object findObjectFactory(Class<?> type)

      Attempts to locate `XmlRegistry` for the XML type. Usually, a class named ObjectFactory is located in the same package as the type we're trying to marshall. This method simply locates this class and instantiates it if found.
      Parameters:
        `t` -
        `type` -
      Returns:

    - #### wrapInJAXBElement

          public static JAXBElement<?> wrapInJAXBElement(Object t,
                                         Class<?> type)

      If this object is managed by an XmlRegistry, this method will invoke the registry and wrap the object in a JAXBElement so that it can be marshalled.
      Parameters:
        `t` -
        `type` -
      Returns:

Copyright © 2014. All Rights Reserved.